#include <TQObject.h>
#include <RQ_OBJECT.h>
#include <TROOT.h>
#include <TClass.h>
#include <TGClient.h>
#include <TGMenu.h>
#include <TGTextEdit.h>
#include <TThread.h>
#include <TH1F.h>
#include <TGraph.h>
#include <TBenchmark.h>
#include <TGTextEditor.h>
#include "CAENDigitizer.h"

#include "macro.h"
#include "DigitizerPHA.h"
#include "DigitizerPSD.h"

#include "boardSetting.h"
#include "channelSetting.h"

///#include "settingsSummary.h"
///#include "scalarPanel.h"
class TGWindow;
class TGMainFrame;
class TRootEmbeddedCanvas;
class TGNumberEntry;
class MainWindow{
   RQ_OBJECT("MainWindow")
private:
   TGMainFrame         *fMain;
   static TRootEmbeddedCanvas *fEcanvas;
   
   TGMenuBar          *fMenuBar;
   TGPopupMenu        *fMenuFile, *fMenuDigitizers, *fMenuUtility;
   
   //static TGNumberEntry * boardIDEntry, *chEntry; 
   //TGNumberEntry * runIDEntry;
   //TGTextEntry * tePath;
   //
   static TGTextEdit * teLog;
   //
   //TGTextButton *bStartRun;
   //TGTextButton *bStopRun;
   //TGTextButton *bFitTrace;
   
   unsigned short nDigi;
   vector<int> DPPType;
   vector<int> portID;
   vector<int> boardID;
   vector<int> serialNum;
   static Digitizer ** digi;
   unsigned short nPHA, nPSD;
   static DigitizerPHA ** pha;
   static DigitizerPSD ** psd;
   
   BoardSetting * boardSetting;
   ChannelSetting * channelSetting;
   //SettingsSummary * settingsSummary;

   //ScalarPanel * scalarPanel;
   //
   //TThread * saveDataThread;
   //TThread * fillHistThread;
   //static TH1F * hEnergy[MAXMOD][MAXCH];
   //static TH1F * hChannel[MAXMOD];
   //static bool isEnergyHistFilled;
   //TGraph * gTrace;
   //
   //TGTextEditor * configEditor;
   
public:
   MainWindow(const TGWindow *p, UInt_t w, UInt_t h);
   virtual ~MainWindow();
   
   void HandleMenu(Int_t id);
   
   void DetectDigitizer();
   
   //void GetADCTrace();
   //void GetBaseLine();
   //void Scope();
   //void FitTrace();
   //void StartRun();
   //static void * SaveData(void* ptr ); /// thread
   //void StopRun();
   //void OpenScalar();
   //static void * FillHistogram(void * ptr); /// thread
   //void ChangeMod();
   //void ChangeChannel();
   
   void LogMsg(TString msg);
   void GoodBye();
};
